--- a/lib/number.vala	Fri Jan 29 16:44:36 2016
+++ b/lib/number.vala	Mon Feb  1 12:02:40 2016
@@ -1340,23 +2825,146 @@
         }
     }
 
+    /* z = sin (x) -1 >= x >= 1, do_sin = 1
+     * z = cos (x) -1 >= x >= 1, do_sin = 0
+     */
+    private Number sin1 (bool do_sin)
+    {
+        /* sin (0) = 0, cos (0) = 1 */
+        if (is_zero ())
+        {
+            if (do_sin)
+                return new Number.integer (0);
+            else
+                return new Number.integer (1);
+        }
+
+        var t2 = multiply (this);
+        if (t2.compare (new Number.integer (1)) > 0)
+            mperr ("*** ABS (X) > 1 IN CALL TO SIN1 ***");
+
+        Number t1;
+        int i;
+        Number z;
+        if (do_sin)
+        {
+            t1 = this;
+            z = t1;
+            i = 2;
+        }
+        else
+        {
+            t1 = new Number.integer (1);
+            z = new Number.integer (0);
+            i = 1;
+        }
+
+        /* Taylor series */
+        /* POWER SERIES LOOP.  REDUCE T IF POSSIBLE */
+        var b2 = 2 * int.max (BASE, 64);
+        do
+        {
+            if (T + t1.re_exponent <= 0)
+                break;
+
+            /*  IF I*(I+1) IS NOT REPRESENTABLE AS AN INTEGER, THE FOLLOWING
+             *  DIVISION BY I*(I+1) HAS TO BE SPLIT UP.
+             */
+            t1 = t2.multiply (t1);
+            if (i > b2)
+            {
+                t1 = t1.divide_integer (-i);
+                t1 = t1.divide_integer (i + 1);
+            }
+            else
+                t1 = t1.divide_integer (-i * (i + 1));
+            z = t1.add (z);
+
+            i += 2;
+        } while (t1.re_sign != 0);
+
+        if (!do_sin)
+            z = z.add (new Number.integer (1));
+
+        return z;
+    }
+
+
     private Number sin_real (AngleUnit unit)
     {
+        /* sin (0) = 0 */
+        if (is_zero ())
+            return new Number.integer (0);
+
         var x_radians = to_radians (unit);
-        var z = new Number.integer (0);
-        var tmp = z.re_num;
-        tmp.sin (x_radians.re_num, Round.NEAREST);
-        z.re_num = tmp;
+
+        var xs = x_radians.re_sign;
+        x_radians = x_radians.abs ();
+
+        /* USE SIN1 IF ABS (X) <= 1 */
+        Number z;
+        if (x_radians.compare (new Number.integer (1)) <= 0)
+            z = x_radians.sin1 (true);
+        /* FIND ABS (X) MODULO 2PI */
+        else
+        {
+            z = new Number.pi ().divide_integer (4);
+            x_radians = x_radians.divide (z);
+            x_radians = x_radians.divide_integer (8);
+            x_radians = x_radians.fractional_component ();
+
+            /* SUBTRACT 1/2, SAVE re_sign AND TAKE ABS */
+            x_radians = x_radians.add (new Number.fraction (-1, 2));
+            xs = -xs * x_radians.re_sign;
+            if (xs == 0)
+                return new Number.integer (0);
+
+            x_radians.re_sign = 1;
+            x_radians = x_radians.multiply_integer (4);
+
+            /* IF NOT LESS THAN 1, SUBTRACT FROM 2 */
+            if (x_radians.re_exponent > 0)
+                x_radians = x_radians.add (new Number.integer (-2));
+
+            if (x_radians.is_zero ())
+                return new Number.integer (0);
+
+            x_radians.re_sign = 1;
+            x_radians = x_radians.multiply_integer (2);
+
+            /*  NOW REDUCED TO FIRST QUADRANT, IF LESS THAN PI/4 USE
+             *  POWER SERIES, ELSE COMPUTE COS OF COMPLEMENT
+             */
+            if (x_radians.re_exponent > 0)
+            {
+                x_radians = x_radians.add (new Number.integer (-2));
+                x_radians = x_radians.multiply (z);
+                z = x_radians.sin1 (false);
+            }
+            else
+            {
+                x_radians = x_radians.multiply (z);
+                z = x_radians.sin1 (true);
+            }
+        }
+
+        z.re_sign = xs;
         return z;
     }
 
     private Number cos_real (AngleUnit unit)
     {
-        var x_radians = to_radians (unit);
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.cos (x_radians.re_num, Round.NEAREST);
-        var z = new Number.mpfloat (tmp);
-        return z;
+        /* cos (0) = 1 */
+        if (is_zero ())
+            return new Number.integer (1);
+
+        /* Use power series if |x| <= 1 */
+        var z = to_radians (unit).abs ();
+        if (z.compare (new Number.integer (1)) <= 0)
+            return z.sin1 (false);
+        else
+            /* cos (x) = sin (π/2 - |x|) */
+            return new Number.pi ().divide_integer (2).subtract (z).sin (AngleUnit.RADIANS);
     }
 
     private Number bitwise (Number y, BitwiseFunc bitwise_operator, int wordlen)
@@ -1370,7 +2978,7 @@
             offset_out = offset1 > offset2 ? offset1 : offset2;
         if (offset_out > 0 && (offset_out < offset1 || offset_out < offset2))
         {
-            error = ("Overflow. Try a bigger word size");
+            mperr ("Overflow. Try a bigger word size");
             return new Number.integer (0);
         }
 
@@ -1420,6 +3028,29 @@
 
 // FIXME: Re-add overflow and underflow detection
 
+static string? mp_error = null;
+
+/*  THIS ROUTINE IS CALLED WHEN AN ERROR CONDITION IS ENCOUNTERED, AND
+ *  AFTER A MESSAGE HAS BEEN WRITTEN TO STDERR.
+ */
+public void mperr (string text)
+{
+    mp_error = text;
+}
+
+/* Returns error string or null if no error */
+// FIXME: Global variable
+public string mp_get_error ()
+{
+    return mp_error;
+}
+
+/* Clear any current error */
+public void mp_clear_error ()
+{
+    mp_error = null;
+}
+
 /* Sets z from a string representation in 'text'. */
 public Number? mp_set_from_string (string str, int default_base = 10)
 {
@@ -1468,7 +3099,6 @@
 
     /* Convert integer part */
     var z = new Number.integer (0);
-
     while (str.get_next_char (ref index, out c))
     {
         var i = char_val (c, number_base);
@@ -1600,6 +3230,73 @@
         return null;
 }
 
+/*  RETURNS K = K/GCD AND L = L/GCD, WHERE GCD IS THE
+ *  GREATEST COMMON DIVISOR OF K AND L.
+ *  SAVE INPUT PARAMETERS IN LOCAL VARIABLES
+ */
+public void mp_gcd (ref int64 k, ref int64 l)
+{
+    var i = k.abs ();
+    var j = l.abs ();
+    if (j == 0)
+    {
+        /* IF J = 0 RETURN (1, 0) UNLESS I = 0, THEN (0, 0) */
+        k = 1;
+        l = 0;
+        if (i == 0)
+            k = 0;
+        return;
+    }
+
+    /* EUCLIDEAN ALGORITHM LOOP */
+    do
+    {
+        i %= j;
+        if (i == 0)
+        {
+            k = k / j;
+            l = l / j;
+            return;
+        }
+        j %= i;
+    } while (j != 0);
+
+    /* HERE J IS THE GCD OF K AND L */
+    k = k / i;
+    l = l / i;
+}
+
+// FIXME: Is r.re_fraction large enough?  It seems to be in practise but it may be T+4 instead of T
+// FIXME: There is some sort of stack corruption/use of unitialised variables here.  Some functions are
+// using stack variables as x otherwise there are corruption errors. e.g. "Cos (45) - 1/Sqrt (2) = -0"
+// (try in scientific mode)
+public void mp_normalize (ref Number x)
+{
+    int start_index;
+
+    /* Find first non-zero digit */
+    for (start_index = 0; start_index < SIZE && x.re_fraction[start_index] == 0; start_index++);
+
+    /* Mark as zero */
+    if (start_index >= SIZE)
+    {
+        x.re_sign = 0;
+        x.re_exponent = 0;
+        return;
+    }
+
+    /* Shift left so first digit is non-zero */
+    if (start_index > 0)
+    {
+        x.re_exponent -= start_index;
+        var i = 0;
+        for (; (i + start_index) < SIZE; i++)
+            x.re_fraction[i] = x.re_fraction[i + start_index];
+        for (; i < SIZE; i++)
+            x.re_fraction[i] = 0;
+    }
+}
+
 /* Returns true if x is cannot be represented in a binary word of length 'wordlen' */
 public bool mp_is_overflow (Number x, int wordlen)
 {

--- gnome-calculator-3.18.2/configure.ac	2016-08-09 14:02:40.743464258 +0000
+++ gnome-calculator-3.18.2/configure.ac	2016-08-09 14:02:52.623794159 +0000
@@ -25,9 +25,6 @@
 
 AC_SUBST([GLIB_REQUIRED])
 
-# FIXME We link to it too, so this check needs to be better....
-AC_CHECK_HEADER([mpfr.h], [], [AC_MSG_ERROR([The mpfr header is missing. Please, install mpfr])])
-
 PKG_CHECK_MODULES(LIBCALCULATOR, [
     glib-2.0 >= $GLIB_REQUIRED
     gio-2.0 >= $GLIB_REQUIRED
